# CellTracking.py
# By MW, Jun 2013
# GPLv3+
#
# Module managing contrast

import numpy, cv2

class Contrast :
    def __init__(self) :
        pass
    def overlay(self, img, contrast=1, auto=False) :
        """Function doing modifying the image"""
        #return img
        #return cv2.convertScaleAbs(img, alpha=0.2*contrast)
        if (contrast != 1) and (not auto) :
            #img=img.astype(numpy.uint16)
            img0 = numpy.minimum(img[:,:,0]*(1+contrast/10.), 255)
            img1 = numpy.minimum(img[:,:,1]*(1+contrast/10.), 255)
            img2 = numpy.minimum(img[:,:,2]*(1+contrast/10.), 255)
            img[:,:,0]=img0
            img[:,:,1]=img1
            img[:,:,2]=img2
            img.dtype = numpy.uint8
            return img
        elif auto :
            return self.autocontrast(img)
        else :
            return img

    def autocontrast(self, im, nbr_bins=256) :
        # From http://www.janeriksolem.net/2009/06/histogram-equalization-with-python-and.html
        #get image histogram
        imhist,bins = numpy.histogram(im.flatten(),nbr_bins,normed=True)
        cdf = imhist.cumsum() #cumulative distribution function
        cdf = 255 * cdf / cdf[-1] #normalize
        
        #use linear interpolation of cdf to find new pixel values
        im2 = numpy.interp(im.flatten(),bins[:-1],cdf)
        return im2.reshape(im.shape).astype('uint8')#, cdf

