# Pyhton script that serves as an example for the CellTracking features.
# Main programmable interface to CellTracking. This script is devoted to all the testing.
# by MW, Jun 2013, GPLv3+


import CellTracking  # Import all the cool stuff :)
import sys, os # And some serious stuff

# ===== Functions
def new_cell(player, coord, name,already_init=False) :
    """Function that create a new cell"""
    c = player.cells.new_cell_panel.new_cell('pol') # Create a gtk cell object
    #c.close() # Init the cell
    c.new_cell(name)
    #c.cell.set_name(name)
    c.cell.cell_pol.add_timepoint(0, coord) # Add some points into the cell
    c.init_ref(20)
    c.visible = True
    if not already_init :
        player.cells.hide_show_panel() # Show the cells panel (required before adding a new cell)
        player.cells.hide_show_panel() # Hide it right after this

    player.cells.add_cell(name, c)
    

# ===== Main


# == Loading frames
img_paths = ["1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "8.png", "9.png", "10.png", "11.png", "12.png", "13.png", "14.png", "15.png"] # Lets define some data!
img_paths2 = ["./demo/1/1.png", "./demo/1/2.png", "./demo/1/3.png", "./demo/1/4.png", "./demo/1/5.png", "./demo/1/6.png", "./demo/1/7.png", "./demo/1/8.png", "./demo/1/9.png", "./demo/1/10.png", "./demo/1/11.png", "./demo/1/12.png", "./demo/1/13.png", "./demo/1/14.png", "./demo/1/15.png"]
#img_paths = ['./demo/tifimage.tif']

graphical = 2

if graphical == 0:
    # Option1: graphical loader
    loader = CellTracking.GraphicalLoader 
    loader.run_panel() # Graphically select files
    frames_object = loader.get_frames_object()
elif graphical == 1:
    # Option2: command line loader
    frames_object = {'type' : 'frames',
                      'value' : 
                     [{'name': 'Ch1',
                      'folder' : './demo/1/',
                      'frames' : img_paths},
                     {'name': 'Ch2',
                      'folder' : './demo/2/',
                      'frames' : img_paths}]}
elif graphical == 2 :
    # Option3: load saved file
    frames_object = {'type' : 'savefile', 'value' : './demo/demo.ct'}

if frames_object == None :
    sys.exit(0)

m = CellTracking.Movies.new_movie() # Initialize a new movie

# == Loading data
if frames_object['type'] == 'frames' :
    channels_list = []
    for ch in frames_object['value'] :
        channel = m.Channels.new_channel(ch['name']) # Create a new channel
        path = []
        folder = ch['folder']
        for p in ch['frames'] :
            #print os.path.join(folder, p)
            path.append(os.path.join(folder, p))
        channel.Loader.load(path,"list_files")#Load files into the channel
        channels_list.append(channel)
elif frames_object['type'] == 'savefile' :
    io = CellTracking.ImportExport
    io.set_path(frames_object['value'])
    io.set_movie(m)
    io.load()


s = CellTracking.States.new_state(m) # Create a state to initialize a player
p = CellTracking.Players.new_player(s) # Initialize a player related to the state instance

# == Adding cells
#c1 = new_cell(p, [(10,10), (200,10), (10,200)], 'bbc1') # Add a new cell
#c2 = new_cell(p, [(400,400), (400,20), (200,400)], 'bbc2') # Add a new cell
p.cells.hide_show_panel() # Show cells panel
#p.cells.hide_show_new_cell_panel('pol') # Create a polygon cell (show the panel)

#p.contrast.hide_show_panel() # Show the contrast panel

p.start() # Start the player (starts gtk.main())
